#### Linux From Scratch - Version 7.9

### Chapter 6. Installing Basic System Software

- Prev

  Readline-6.3

- Next

  Bc-1.06.95

- Up
- Home

# 6.35. Bash-4.3.30

The Bash package contains the Bourne-Again SHell.

Approximate build time: 1.9 SBU
Required disk space: 49 MB

## 6.35.1. Installation of Bash

First, apply the following patch to fix various bugs that have been addressed upstream:

    patch -Np1 -i ../bash-4.3.30-upstream_fixes-3.patch

Prepare Bash for compilation:

    ./configure --prefix=/usr                       \
                --docdir=/usr/share/doc/bash-4.3.30 \
                --without-bash-malloc               \
                --with-installed-readline

The meaning of the new configure option:

`--with-installed-readline`

  This option tells Bash to use the `readline` library that is already installed on the system rather than using its own readline version.

Compile the package:

    make

Skip down to “Install the package” if not running the test suite.

To prepare the tests, ensure that the `nobody` user can write to the sources tree:

    chown -Rv nobody .

Now, run the tests as the `nobody` user:

    su nobody -s /bin/bash -c "PATH=$PATH make tests"

Install the package and move the main executable to `/bin`:

    make install
    mv -vf /usr/bin/bash /bin

Run the newly compiled bash program (replacing the one that is currently being executed):

    exec /bin/bash --login +h

### Note

The parameters used make the bash process an interactive login shell and continue to disable hashing so that new programs are found as they become available.

## 6.35.2. Contents of Bash

Installed programs: bash, bashbug, and sh (link to bash)
Installed directory: /usr/share/doc/bash-4.3.30

### Short Descriptions

bash | A widely-used command interpreter; it performs many types of expansions and substitutions on a given command line before executing it, thus making this interpreter a powerful tool
bashbug | A shell script to help the user compose and mail standard formatted bug reports concerning bash
sh | A symlink to the bash program; when invoked as sh, bash tries to mimic the startup behavior of historical versions of sh as closely as possible, while conforming to the POSIX standard as well

- Prev

  Readline-6.3

- Next

  Bc-1.06.95

- Up
- Home